Bug 862211 - fuseiso: stack-based buffer overflow in isofs_real_readdir
Summary: fuseiso: stack-based buffer overflow in isofs_real_readdir
Keywords:
Status: NEW
Alias: None
Product: Fedora
Classification: Fedora
Component: fuseiso
Version: 27
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Orphan Owner
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 861356 CVE-2015-8837
TreeView+ depends on / blocked
 
Reported: 2012-10-02 09:59 UTC by Florian Weimer
Modified: 2020-07-24 22:35 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2016-12-20 12:27:46 UTC
Type: Bug


Attachments (Terms of Use)
Bail out if absolute path names exceed PATH_MAX (1.32 KB, patch)
2015-10-01 08:54 UTC, Mike Gabriel
no flags Details | Diff
deep-tree.iso.gz (5.10 KB, application/octet-stream)
2015-10-01 09:29 UTC, Florian Weimer
no flags Details

Description Florian Weimer 2012-10-02 09:59:40 UTC
In isofs.c:isofs_real_readdir(), this excerpt looks like a potential stack-based buffer overflow:

            char absolute_entry[PATH_MAX];
            strcpy(absolute_entry, path);
            if(path[1] != '\0') { // not root dir
                strcat(absolute_entry, "/");
            };
            strcat(absolute_entry, entry);

Full path names could be longer than PATH_MAX characters.

Comment 1 Florian Weimer 2012-10-02 10:11:22 UTC
A reproducer is available upon request (deep-tree.iso).

Comment 2 Florian Weimer 2012-10-02 10:16:31 UTC
This is caught by FORTIFY_SOURCE, so it's not exploitable for code execution.

Comment 3 Florian Weimer 2012-10-02 13:40:10 UTC
(In reply to comment #1)
> A reproducer is available upon request (deep-tree.iso).

The reproducer requires reading the directory to trigger.  Invoking "find" on the mountpoint is sufficient to achieve that.

Comment 7 Jaroslav Reznik 2013-04-05 12:24:37 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 19 development cycle.
Changing version to '19'.

(As we did not run this process for some time, it could affect also pre-Fedora 19 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 19 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora19

Comment 8 Fedora Admin XMLRPC Client 2015-03-30 20:13:58 UTC
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.

Comment 9 Jan Kurik 2015-07-15 14:58:43 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 23 development cycle.
Changing version to '23'.

(As we did not run this process for some time, it could affect also pre-Fedora 23 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 23 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora23

Comment 10 Mike Gabriel 2015-10-01 04:02:26 UTC
(In reply to Florian Weimer from comment #1)
> A reproducer is available upon request (deep-tree.iso).

On behalf of the Debian LTS Team, I have started on working out a patch for this issue. Florian, could you provide me with that crafted deep-tree.iso file, if you still have it. That would speed up testing here. Thanks.

Comment 11 Mike Gabriel 2015-10-01 08:54:22 UTC
Created attachment 1078987 [details]
Bail out if absolute path names exceed PATH_MAX

Comment 12 Florian Weimer 2015-10-01 09:29:29 UTC
Created attachment 1078998 [details]
deep-tree.iso.gz

Reproducer

Comment 13 Fedora End Of Life 2016-11-24 10:49:43 UTC
This message is a reminder that Fedora 23 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 23. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '23'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 23 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 14 Fedora End Of Life 2016-12-20 12:27:46 UTC
Fedora 23 changed to end-of-life (EOL) status on 2016-12-20. Fedora 23 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Comment 15 Jan Kurik 2018-05-31 07:26:32 UTC
This bug has been reported against a Fedora version which is already unsuported.
In compliance with FESCo decision how to handle EOL of Security issues [1],
I am changing the version to '27', the latest supported release.

Please check whether this bug is still an issue on the '27' release.
If you find this bug not being applicable on this release, please close it.

[1] https://pagure.io/fesco/issue/1736

Comment 16 Ben Cotton 2018-11-27 15:33:44 UTC
This message is a reminder that Fedora 27 is nearing its end of life.
On 2018-Nov-30  Fedora will stop maintaining and issuing updates for
Fedora 27. It is Fedora's policy to close all bug reports from releases
that are no longer maintained. At that time this bug will be closed as
EOL if it remains open with a Fedora  'version' of '27'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 27 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.


Note You need to log in before you can comment on or make changes to this bug.